Package: org.codehaus.groovy.classgen.asm

## [Java] Class CallSiteWriter

- org.codehaus.groovy.classgen.asm.CallSiteWriter

-     public class CallSiteWriter
      extends Object

  This class represents non-public API used by AsmClassGenerator. Don't use this class in your code

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `CONSTRUCTOR` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `CallSiteWriter(WriterController wc)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `fallbackAttributeOrPropertySite(PropertyExpression expression, Expression objectExpression, String name, MethodCallerMultiAdapter adapter)`
    `` | `public void` | `generateCallSiteArray()`
    `` | `public List<String>` | `getCallSites()`
    `` | `public boolean` | `hasCallSiteUse()`
    `` | `public boolean` | `isPrologueEmitted()` Returns true if a call-site array loading prologue has been emitted for at least one method of the current class.
    `` | `public void` | `makeCallSite(Expression receiver, String message, Expression arguments, boolean safe, boolean implicitThis, boolean callCurrent, boolean callStatic)`
    `` | `public void` | `makeCallSiteArrayInitializer()`
    `` | `public void` | `makeGetPropertySite(Expression receiver, String methodName, boolean safe, boolean implicitThis)`
    `` | `public void` | `makeGroovyObjectGetPropertySite(Expression receiver, String methodName, boolean safe, boolean implicitThis)`
    `` | `public final void` | `makeSingleArgumentCall(Expression receiver, String message, Expression arguments)`
    `` | `public void` | `makeSingleArgumentCall(Expression receiver, String message, Expression arguments, boolean safe)`
    `` | `public void` | `makeSiteEntry()`
    `` | `public void` | `prepareCallSite(String message)`
    `` | `protected void` | `prepareSiteAndReceiver(Expression receiver, String methodName, boolean implicitThis, boolean lhs)`
    `` | `protected void` | `visitBoxedArgument(Expression exp)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### public static final String CONSTRUCTOR

  - ### Constructor Detail

    - #### public CallSiteWriter(WriterController wc)

  - ### Method Detail

    - #### public void fallbackAttributeOrPropertySite(PropertyExpression expression, Expression objectExpression, String name, MethodCallerMultiAdapter adapter)

    - #### public void generateCallSiteArray()

    - #### public List<String> getCallSites()

    - #### public boolean hasCallSiteUse()

    - #### public boolean isPrologueEmitted()

      Returns true if a call-site array loading prologue has been emitted for at least one method of the current class.

    - #### public void makeCallSite(Expression receiver, String message, Expression arguments, boolean safe, boolean implicitThis, boolean callCurrent, boolean callStatic)

    - #### public void makeCallSiteArrayInitializer()

    - #### public void makeGetPropertySite(Expression receiver, String methodName, boolean safe, boolean implicitThis)

    - #### public void makeGroovyObjectGetPropertySite(Expression receiver, String methodName, boolean safe, boolean implicitThis)

    - #### public final void makeSingleArgumentCall(Expression receiver, String message, Expression arguments)

    - #### public void makeSingleArgumentCall(Expression receiver, String message, Expression arguments, boolean safe)

    - #### public void makeSiteEntry()

    - #### public void prepareCallSite(String message)

    - #### protected void prepareSiteAndReceiver(Expression receiver, String methodName, boolean implicitThis, boolean lhs)

    - #### protected void visitBoxedArgument(Expression exp)